<?php

/*
----------------------------------------------------------

//HTML Form
<form action="jоin.рhр" id="contact_form">
<div class="row collapse in" id="tickedform">
	<div class="form-group col-md-4"><label class="control-label" for="email">Email</label> <input required="true" name='email' type="email" id="email" class="form-control" placeholder="Valid jabber address"></div>
	<div class="form-group col-md-4"><label class="control-label" for="name">Name</label> <input required="true" name='name' type="name" id="name" class="form-control" placeholder="Nickname while working on the Web" value=""></div>
	<div class="form-group col-md-4"><label class="control-label" for="subject">Subject</label><select name="subject" class="form-control"><option value="Question">Question</option><option value="Audit">Audit</option><option value="Partnership">Partnership</option></select>
   </div>
	<div class="form-group col-md-12"><label class="control-label" for="message">Message</label> 
		<textarea required="true" name="message" id="message" class="form-control" rows="5" minlength="200" maxlength="4000" placeholder="The most important field. Here you must specify the service area of knowledge related to IT, their skills in different areas, their achievements, releases and profiles on famous it-portals, the potential usefulness of the project and so on. A small description of yourself is encouraged. You can also leave a jabber and other alternative addresses for communication, in short, everything that you see fit to bring to our attention."></textarea></div>
	</div>
</div>
</form>
<div class="col-md-12" id="output"></div>
<div class="modal-footer collapse in"><button class="btn btn-default" data-dismiss="modal">Close</button> <button type="button" name="submit" class="btn btn-success" data-send="tickedform">Send</button></div>
</div>

----------------------------------------------------------
	
//Modal Form Script 
$(document).ready(function() {
		$('[data-send="tickedform"]').click(function() { 		
		var proceed = true;     
        $("#contact_form input[required=true], #contact_form textarea[required=true]").each(function(){
            $(this).parent().removeClass('has-error'); 
            if(!$.trim($(this).val())){ 
                $(this).parent().addClass('has-error');  
                proceed = false;
            }
            var email_reg = /^([\w-\.]+@([\w-]+\.)+[\w-]{2,4})?$/; 
            if($(this).attr("type")=="email" && !email_reg.test($.trim($(this).val()))){
                $(this).parent().addClass('has-error'); 
                proceed = false;            
            }   
        });
        if(proceed) {
            post_data = {
                'user_name'     : $('input[name=name]').val(), 
                'user_email'    : $('input[name=email]').val(),  
                'subject'       : $('select[name=subject]').val(), 
                'msg'           : $('textarea[name=message]').val()
            };
            $.post('mail.php', post_data, function(response){  
                if(response.type == 'error'){    
	                $("#output").html(output);
                    output = '<div class="alert alert-danger">'+response.text+'</div>';
                }else{
                    output = '<div class="alert alert-success">'+response.text+'</div>';
                    $("#contact_form  input[required=true], #contact_form textarea[required=true]").val(''); 
                    $("#tickedform").slideUp();
                    $('[data-send="tickedform"]').hide();
                }
                $("#output").hide().html(output).slideDown();
            }, 'json');
        }
		});
	
		$('#contact_form  input[required=true], #contact_form textarea[required=true]').keyup(function() { 
        $(this).parent().removeClass('has-error'); 
        $("#output").html('').slideDown();
		 });
   });

----------------------------------------------------------
*/

if($_POST)
{
    $to_email       = "wo0rmin@gmail.com";
    if(!isset($_SERVER['HTTP_X_REQUESTED_WITH']) AND strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) != 'xmlhttprequest') {
        $output = json_encode(array(
            'type'=>'error', 
            'text' => 'Sorry Request must be Ajax POST'
        ));
        die($output);
    } 
    $user_name      = filter_var($_POST["user_name"], FILTER_SANITIZE_STRING);
    $user_email     = filter_var($_POST["user_email"], FILTER_SANITIZE_EMAIL);
    $subject        = filter_var($_POST["subject"], FILTER_SANITIZE_STRING);
    $message        = filter_var($_POST["msg"], FILTER_SANITIZE_STRING);
    
    //additional php validation
    if(strlen($user_name)<4){
        $output = json_encode(array('type'=>'error', 'text' => 'Name is too short or empty!'));
        die($output);
    }
    if(!filter_var($user_email, FILTER_VALIDATE_EMAIL)){
        $output = json_encode(array('type'=>'error', 'text' => 'Please enter a valid email!'));
        die($output);
    }
    if(strlen($subject)<3){
        $output = json_encode(array('type'=>'error', 'text' => 'Subject is required'));
        die($output);
    }
    if(strlen($message)<50){
        $output = json_encode(array('type'=>'error', 'text' => 'Too short message! Please enter your message...'));
        die($output);
    }
    
    //email body
    $message_body = $message."\r\n\r\n-".$user_name."\r\nEmail : ".$user_email;
    
    //proceed with PHP email.
    $headers = 'From: '.$user_name.'' . "\r\n" .
    'Reply-To: '.$user_email.'' . "\r\n" .
    'X-Mailer: PHP/' . phpversion();
    
    $send_mail = mail($to_email, $subject, $message_body, $headers);
    
    
    if(!$send_mail)
    {
        //If mail couldn't be sent output error. Check your PHP email configuration (if it ever happens)
        $output = json_encode(array('type'=>'error', 'text' => 'Could not send mail :-/'));
        die($output);
    }else{
        
        //Jabber
        include 'XMPPHP/XMPP.php';
        $conn = new XMPPHP_XMPP('w0rm.ws', 5222, 'root', 'O56Vt9X-SK', 'invite bot', 'w0rm.ws', $printlog=false, $loglevel=XMPPHP_Log::LEVEL_INFO);
        try {
            $conn->connect();
            $conn->processUntil('session_start');
            $conn->presence();
            $conn->message('w0rm@cih.ms', $user_email);
            $conn->message('w0rm@cih.ms', $message);
            $conn->message('admin@w0rm.ws', $user_email);
            $conn->message('admin@w0rm.ws', $message);
            $conn->disconnect();
        } catch(XMPPHP_Exception $e) {
            die($e->getMessage());
        }

        $output = json_encode(array('type'=>'message', 'text' => 'Great '.$user_name .'! Thank you for your request'));
        die($output);
    }
}
?>